=begin
njeremy2 may 2012
=end

Sketchup::require 'sketchup'

#We retrive the face to bore a hole. We use the pushpull to the next face.
class Trouer

  #Initialisation
  def activate
    Sketchup.status_text = 'Cliquez sur une face pour la trouer'
  end
  
  #When we push left button, we check if the selected thing is a face, then we use "trouerFace"
  def onLButtonDown(flags, x, y, view)
    pickHelper = view.pick_helper
    pickHelper.do_pick(x, y)
    face = pickHelper.picked_face
    trouerFace(face) if face
  end
  
  # Make a hole on the nearest face selected.
  def trouerFace(face)
    entities = face.parent.entities
    model = face.model
    normal =  face.normal.reverse
    for e in entities
      # Verify entity
      next if e == face
      next unless e.is_a?( Sketchup::Face )
      next unless e.normal.samedirection?( normal )
      # Find offset length
      line = [ face.vertices[0].position, normal ]
      pt = Geom.intersect_line_plane( line, e.plane )
      distance = face.vertices[0].position.distance( pt )
      # Ensure all vertices in 'face' are inside of target face 'e'
      next unless face.vertices.all? { |v|
        offset_pt = v.position.offset( normal, distance )
        case e.classify_point( offset_pt )
          when Sketchup::Face::PointInside,
               Sketchup::Face::PointOnVertex,
               Sketchup::Face::PointOnEdge
            face.pushpull( -distance )
            return true
        end
      }
    end
  end
  
end # class Trouer


unless file_loaded?("testhole.rb")
  UI.menu("Plugins").add_item("njeremy2 Hole") {
    Sketchup.active_model.select_tool( Trouer.new )
  }
end
#---------------------------------------------------------------------------
file_loaded("testhole.rb")